"{ Package: 'stx:libjava' }"

JavaNode subclass:#JavaMethodNode
	instanceVariableNames:'modifiers type declarator startPosition javadoc'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-AST'
!


!JavaMethodNode methodsFor:'accessing'!

declarator
    ^ declarator
!

declarator:something
    declarator := something.
!

javadoc
    ^ javadoc
!

javadoc:something
    javadoc := something.
!

modifiers
    ^ modifiers
!

modifiers:something
    modifiers := something.
!

selector
    | name |
"/    self halt: 'does not work properly ;('.
    name := self declarator identifier.
    name := name, '('.
    name := name, (self declarator parameterSelector).
    name := name, ')', (self type selector).

    ^name.

    "Created: / 13-12-2010 / 14:35:06 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-12-2010 / 17:47:10 / Jan Kurs <kurs.jan@post.cz>"
!

startPosition
    startPosition ifNil: [ startPosition := self determineStartPosition. ].
    ^ startPosition

    "Modified: / 13-12-2010 / 10:35:47 / Jan Kurs <kurs.jan@post.cz>"
!

type
    ^ type
!

type:something
    type := something.
! !

!JavaMethodNode methodsFor:'printing & storing'!

printOn:aStream
    aStream nextPutAll: self selector.

    "Created: / 17-12-2010 / 17:38:20 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaMethodNode methodsFor:'private'!

determineStartPosition
    self javadoc ifNotNil: [ ^ self javadoc lineNumber].
    (self modifiers size > 0) ifTrue:[
        ^ self modifiers first lineNumber
    ].
    ^ self type lineNumber.

    "Created: / 13-12-2010 / 10:34:01 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-12-2010 / 18:19:30 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaMethodNode methodsFor:'queries'!

isMethodDeclaration
    ^ true.

    "Created: / 13-12-2010 / 14:34:14 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaMethodNode class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
