"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libjava' }"

Object subclass:#JavaRef
	instanceVariableNames:'class nameandType'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Reader-Support'
!

!JavaRef class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


! !

!JavaRef class methodsFor:'instance creation'!

class:aJavaClass nameandType:nameAndType
    ^ self new class:aJavaClass nameandType:nameAndType

    "Created: 15.4.1996 / 16:10:49 / cg"
! !

!JavaRef class methodsFor:'validation'!

validateAll
    self allSubInstancesDo:[:ref |
        ref validateClass
    ]

    "
     self validateAll
    "

    "Created: 20.3.1997 / 00:13:55 / cg"
    "Modified: 20.3.1997 / 00:14:24 / cg"
! !

!JavaRef methodsFor:'accessing'!

class:aJavaClass nameandType:aJavanameAndType
     class := aJavaClass.
     nameandType := aJavanameAndType.
class isNil ifTrue:[self halt].


    "Modified: 15.4.1996 / 16:08:39 / cg"
    "Created: 15.4.1996 / 16:10:37 / cg"
!

javaClass
     ^ class
!

javaClassForLDC
     ^ class

    "Created: / 19-12-2010 / 17:31:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

nameandType
     ^ nameandType

    "Created: / 15.10.1998 / 23:50:44 / cg"
! !

!JavaRef methodsFor:'printing & storing'!

displayString
    |clsName|

    class isJavaClass ifTrue:[
        clsName := class fullName
    ] ifFalse:[
        clsName := class name
    ].
    ^ self class name , '(class:' , clsName , ' ; name&type: ' , nameandType displayString , ')'

    "Created: 15.4.1996 / 16:18:54 / cg"
    "Modified: 7.4.1997 / 13:43:29 / cg"
! !

!JavaRef methodsFor:'queries'!

isUnresolved
    ^ false


! !

!JavaRef methodsFor:'special'!

updateClassRefsFrom:oldClass to:newClass
    class == oldClass ifTrue:[
        newClass isNil ifTrue:[
            class := JavaUnresolvedClassConstant fullName:(class fullName)
        ] ifFalse:[
            class := newClass
        ]
    ] ifFalse:[
        class isJavaClass ifTrue:[
            class fullName = oldClass fullName ifTrue:[
                'JAVA: class update by name.' infoPrintCR.
                class := newClass
            ]
        ]
    ]

    "Created: / 7.8.1997 / 15:01:09 / cg"
    "Modified: / 4.2.1998 / 22:19:23 / cg"
! !

!JavaRef methodsFor:'validation'!

validateClass
    |actualClass|

    class notNil ifTrue:[
        class isJavaClass ifTrue:[
            class ~~ (actualClass := Java at:(class fullName)) ifTrue:[
                Transcript showCR:'updated ref to: ' , class fullName.
                class := actualClass
            ]
        ]
    ].

    "Created: 20.3.1997 / 00:13:27 / cg"
    "Modified: 20.3.1997 / 00:16:54 / cg"
! !

!JavaRef class methodsFor:'documentation'!

version
    ^ '$Id$'
!

version_SVN
    ^ '$Id$'
! !
