"{ Package: 'stx:libjava' }"

JavaRef2 subclass:#JavaRefMock
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests-RuntimeConstantPool'
!


!JavaRefMock methodsFor:'accessing'!

name
    "superclass JavaRef2 says that I am responsible to implement this method"
    
    ^ 'mock name'

    "Modified: / 08-04-2011 / 16:15:38 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaRefMock methodsFor:'comparing'!

= anotherJavaRef
    "superclass JavaRef2 says that I am responsible to implement this method"

    ^ self shouldImplement
!

hash
    "superclass JavaRef2 says that I am responsible to implement this method"

    ^ self shouldImplement
! !

!JavaRefMock methodsFor:'private - resolving'!

findResolvedStaticValue
    "Resolve reference and set valueCache and isResolved."
    
    valueCache := 'static'.

    "Created: / 26-04-2011 / 13:20:05 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

findResolvedValue
    "Resolve reference and set valueCache and isResolved."
    
    valueCache := 'ok'.

    "Modified: / 08-04-2011 / 17:39:50 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaRefMock methodsFor:'resolving'!

invalidateForClass: internalJavaClassName 
    "Invalidate (means call invalidate) reference if it has something to do with given class (e.g Class named internalJavaClassName was unloaded).
     Return true, if reference was invalidated."
    
    internalJavaClassName = 'mock' ifTrue: [self invalidate. ^ true] ifFalse: [^ false].

    "Modified: / 08-04-2011 / 16:16:41 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaRefMock class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !


